package metaData;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

public class DatabaseInfoServlet extends HttpServlet {

  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

public void doGet(HttpServletRequest inRequest,
      HttpServletResponse outResponse) throws ServletException,
      IOException {

    PrintWriter out = null;
    Connection connection = null;
    //Statement statement;
    ResultSet rs;

    outResponse.setContentType("text/html");
    out = outResponse.getWriter();

    try {
      Context ctx = new InitialContext();
      DataSource ds = (DataSource) ctx
          .lookup("java:comp/env/jdbc/jdbcTest");
      connection = ds.getConnection();

      DatabaseMetaData md = connection.getMetaData();
      //statement = connection.createStatement();

      out.println("<html><head><title>Informacio az adatbazis szerverrol</title></head>");
      out.println("<body>");
      out.println("<h1>Általános információ az adatbázisról</h1>");
      out.println("getURL() - " + md.getURL() + "<br>");
      out.println("getUserName() - " + md.getUserName() + "<br>");
      out.println("getDatabaseProductVersion - "
          + md.getDatabaseProductVersion() + "<br>");
      out.println("getDriverMajorVersion - " + md.getDriverMajorVersion()
          + "<br>");
      out.println("getDriverMinorVersion - " + md.getDriverMinorVersion()
          + "<br>");
      out.println("nullAreSortedHigh - " + md.nullsAreSortedHigh()
          + "<br>");

      out.println("<h1>Eszközök támogatottsága</h1>");
      out.println("supportsAlterTableWithDropColumn - "
          + md.supportsAlterTableWithDropColumn() + "<br>");
      out.println("supportsBatchUpdates - " + md.supportsBatchUpdates()
          + "<br>");
      out.println("supportsTableCorrelationNames - "
          + md.supportsTableCorrelationNames() + "<br>");
      out.println("supportsPositionedDelete - "
          + md.supportsPositionedDelete() + "<br>");
      out.println("supportsFullOuterJoins - "
          + md.supportsFullOuterJoins() + "<br>");
      out.println("supportsStoredProcedures - "
          + md.supportsStoredProcedures() + "<br>");
      out.println("supportsMixedCaseQuotedIdentifiers - "
          + md.supportsMixedCaseQuotedIdentifiers() + "<br>");
      out.println("supportsANSI92EntryLevelSQL - "
          + md.supportsANSI92EntryLevelSQL() + "<br>");
      out.println("supportsCoreSQLGrammar - "
          + md.supportsCoreSQLGrammar() + "<br>");

      out.println("<h1>Data Source határok</h1>");
      out.println("getMaxRowSize - " + md.getMaxRowSize() + "<br>");
      out.println("getMaxStatementLength - " + md.getMaxStatementLength()
          + "<br>");
      out.println("getMaxTablesInSelect - " + md.getMaxTablesInSelect()
          + "<br>");
      out.println("getMaxConnections - " + md.getMaxConnections()
          + "<br>");
      out.println("getMaxCharLiteralLength - "
          + md.getMaxCharLiteralLength() + "<br>");

      out.println("<h1>Rendelkezésre álló SQL objektumok</h1>");
      out.println("getTableTypes()<br><ul>");
      rs = md.getTableTypes();
      while (rs.next()) {
        out.println("<li>" + rs.getString(1)+"</li>");
      }
      out.println("</ul>");

      out.println("getTables()<br><ul>");
      rs = md.getTables("jdbcTest", "", "%", new String[0]);
      while (rs.next()) {
        out.println("<li>" + rs.getString("TABLE_NAME")+"</li>");
      }
      out.println("</ul>");

      out.println("<h1>Tranzakció támogatottság</h1>");
      out.println("getDefaultTransactionIsolation() - "
          + md.getDefaultTransactionIsolation() + "<br>");
      out.println("dataDefinitionIgnoredInTransactions() - "
          + md.dataDefinitionIgnoredInTransactions() + "<br>");

      out.println("<h1>További általános információ</h1>");
      out.println("getMaxTablesInSelect - " + md.getMaxTablesInSelect()
          + "<br>");
      out.println("getMaxColumnsInTable - " + md.getMaxColumnsInTable()
          + "<br>");
      out.println("getTimeDateFunctions - " + md.getTimeDateFunctions()
          + "<br>");
      out.println("supportsCoreSQLGrammar - "
          + md.supportsCoreSQLGrammar() + "<br>");

      out.println("getTypeInfo()<br><ul>");
      rs = md.getTypeInfo();
      while (rs.next()) {
        out.println("<li>" + rs.getString(1)+"</li>");
      }
      out.println("</ul>");

      out.println("</body></html>");
    } catch (Exception e) {
      e.printStackTrace();
    }
    finally {
    	try {
    		if (connection!=null) {
    			connection.close();
    		}
		} catch (SQLException e) {
			e.printStackTrace();
		}
    }
    
  }

  public void doPost(HttpServletRequest inRequest,
      HttpServletResponse outResponse) throws ServletException,
      IOException {
    doGet(inRequest, outResponse);
  }
}

           
       